#define false 0
#define true 1
#include <fstream>
#include <iomanip>
#include <iostream>
#include <stdio.h>
#include <tchar.h>
#include <malloc.h>
#include <cctype>

#define null '\0'
#ifndef dwrd
 typedef unsigned char  byte;
 typedef unsigned short word;
 typedef unsigned long  dwrd;
#endif
using namespace std;
int HexString2Integer(const TCHAR *value);


int main(int argc, char *argv[]) 
{
    if (argc==6)
	{
		unsigned long StartOffset;
		unsigned long EndOffset;
		unsigned long CopyToOffset;
	    fstream CopyFromFile(argv[1], fstream::in | fstream::out |ios::binary );;
        fstream CopyToFile(argv[2], fstream::in | fstream::out |ios::binary );
        sscanf(argv[3],"%X",&StartOffset );
        sscanf(argv[4],"%X",&EndOffset );
        sscanf(argv[5],"%X",&CopyToOffset );
        CopyFromFile.seekg (0, ios::end); 
        int CopyFromFileLength = CopyFromFile.tellg();

        CopyToFile.seekg (0, ios::end); 
        int CopyToFileLength = CopyToFile.tellg();
        
		if (!CopyFromFile)
		{
			cout<<"\nError: File "<<argv[1]<<" was not found.\n\n"; 
			return 0;
		} 
		if (!CopyToFile)
		{
			cout<<"\nError: File "<<argv[2]<<" was not found.\n\n"; 
			return 0;
		} 
		
        if (StartOffset>=EndOffset)
		{
			cout<<"\nError: Starting offset is greater than end offset!\n\n";   
			return 0;                      
        }
        int CopyAmount = EndOffset - StartOffset;
        cout<<hex<<CopyAmount;
        if (EndOffset>CopyFromFileLength)
        {
			cout<<"Error: End offsets must be less than file length!\n\n";
			return 0;
        }
    	if (CopyToOffset+CopyAmount>CopyToFileLength)
        {
			cout<<"Warning: Writing past end of copy to file!\n\n";

        }
        
        CopyFromFile.seekg (StartOffset, ios::beg); 
        CopyToFile.seekp (CopyToOffset, ios::beg); 
        
		char * buffer;
		buffer = new char [CopyAmount];
		CopyFromFile.read (buffer,CopyAmount);
		CopyToFile.write(buffer,CopyAmount);
		
		CopyFromFile.close();
		CopyToFile.close();
        
    }
    else
    {
		printf("QuickBlockCopy 1.0 by DaMarsMan\nUsage: QuickBlockCopy <CopyFromFile> <CopyToFile> <FromStartOffset> <FromEndOffset> <CopyToOffset>\nAll offsets should be in hex format without 0x!\n\n");
	}
    return 0;
}




